<?php



include_once (NBC_UserAdvManager_PATH.'include/constants.php');
include_once (NBC_UserAdvManager_PATH.'include/functions_UserAdvManager.inc.php');



function SendMail2User($subject, $id, $username, $password, $email, $confirm=false)
{
  global $conf;
  
  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  include(get_language_filepath('plugin.lang.php', NBC_UserAdvManager_PATH));
  include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');

  if ( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true' )
    $infos1 = array(
      get_l10n_args('User: %s', $username),
      get_l10n_args('Password: %s', $password),
      get_l10n_args('Email: %s', $email),
      get_l10n_args('', ''),
    );

  if ( isset($conf_nbc_UserAdvManager[4]) and $conf_nbc_UserAdvManager[4] == 'true' and $confirm)
  {
    $infos2 = array
    (
      get_l10n_args('UserAdvManager_Confirm_Mail', ''),
      get_l10n_args('Link: %s', AddConfirmMail($id)),
      get_l10n_args('', ''),
    );
  }

  if ( function_exists('get_user_language_desc') and isset($conf_nbc_UserAdvManager[12]) and $conf_nbc_UserAdvManager[12] <> '' )
    $infos_mail = get_user_language_desc($conf_nbc_UserAdvManager[12]);
  else
    $infos_mail = l10n('infos_mail');

  pwg_mail($email, array(
    'subject' => $subject,
    'content' => (isset($infos1) ? $infos_mail."\n\n".l10n_args($infos1)."\n\n" : "").(isset($infos2) ? l10n_args($infos2)."\n\n" : "").get_absolute_root_url(),
  ));
}



function FindAvailableConfirmMailID()
{
  while (true)
  {
    $id = generate_key(16);
    $query = "
      SELECT COUNT(*)
      FROM ".USER_CONFIRM_MAIL_TABLE."
      WHERE id = '".$id."'
    ;";
    list($count) = mysql_fetch_row(pwg_query($query));

    if ($count == 0)
      return $id;
  }
}



function AddConfirmMail($user_id)
{
  global $conf;
  
  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  $Confirm_Mail_ID = FindAvailableConfirmMailID();

  list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));
  
  if ( isset($Confirm_Mail_ID) )
  {
    $query = "
      INSERT INTO ".USER_CONFIRM_MAIL_TABLE."
      (id, user_id, date_check)
      VALUES
      ('".$Confirm_Mail_ID."', '".$user_id."', null)
    ;";
    pwg_query($query);

    $query = "
      DELETE FROM ".USER_GROUP_TABLE."
      WHERE user_id = '".$user_id."'
      AND (
        group_id = '".$conf_nbc_UserAdvManager[5]."'
        OR 
        group_id = '".$conf_nbc_UserAdvManager[6]."'
      )
    ;";
    pwg_query($query);

    if ( $conf_nbc_UserAdvManager[11] <> -1 )
    {
      $query = "
        UPDATE ".USER_INFOS_TABLE."
        SET status = '".$conf_nbc_UserAdvManager[11]."'
        WHERE user_id = '".$user_id."'
      ;";
      pwg_query($query);
    }

    if ( $conf_nbc_UserAdvManager[5] <> -1 )
    {
      $query = "
        INSERT INTO ".USER_GROUP_TABLE."
        (user_id, group_id)
        VALUES
        ('".$user_id."', '".$conf_nbc_UserAdvManager[5]."')
      ;";
      pwg_query($query);
    }
    
    return get_absolute_root_url().NBC_UserAdvManager_PATH.'ConfirmMail.php?key='.$Confirm_Mail_ID;
  }
}



function DeleteConfirmMail($user_id)
{
  $query = "
    DELETE FROM ".USER_CONFIRM_MAIL_TABLE."
    WHERE user_id = '".$user_id."'
  ;";
  pwg_query($query);
}



function VerifyConfirmMail($id)
{
  global $conf;
  
  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  $query = "
    SELECT COUNT(*)
    FROM ".USER_CONFIRM_MAIL_TABLE."
    WHERE id = '".$id."'
  ;";
  list($count) = mysql_fetch_row(pwg_query($query));

  if ($count == 1)
  {
    $query = "
      SELECT user_id, date_check
      FROM ".USER_CONFIRM_MAIL_TABLE."
      WHERE id = '".$id."'
    ;";
    $data = mysql_fetch_array(pwg_query($query));
    
    
    if (!empty($data) and isset($data['user_id']) and !isset($data['date_check']))
    {
      $query = "
        SELECT registration_date
        FROM ".USER_INFOS_TABLE."
        WHERE user_id = '".$data['user_id']."'
      ;";
      list($registration_date) = mysql_fetch_row(pwg_query($query));
  
      if (!empty($registration_date))
      {
// traitement limite date
      }
      
      list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));
  
      $query = '
        UPDATE '.USER_CONFIRM_MAIL_TABLE.'
        SET date_check="'.$dbnow.'"
        WHERE id = "'.$id.'"
      ;';
      pwg_query($query);
      
      if ( $conf_nbc_UserAdvManager[5] <> -1 )
      {
        $query = "
          DELETE FROM ".USER_GROUP_TABLE."
          WHERE user_id = '".$data['user_id']."'
          AND group_id = '".$conf_nbc_UserAdvManager[5]."'
        ;";
        pwg_query($query);
      }
    
      if ( $conf_nbc_UserAdvManager[6] <> -1 )
      {
        $query = "
          DELETE FROM ".USER_GROUP_TABLE."
          WHERE user_id = '".$data['user_id']."'
          AND group_id = '".$conf_nbc_UserAdvManager[6]."'
        ;";
        pwg_query($query);

        $query = "
          INSERT INTO ".USER_GROUP_TABLE."
          (user_id, group_id)
          VALUES
          ('".$data['user_id']."', '".$conf_nbc_UserAdvManager[6]."')
        ;";
        pwg_query($query);
      }
  
      if ( $conf_nbc_UserAdvManager[7] <> -1 )
      {
        $query = "
          UPDATE ".USER_INFOS_TABLE."
          SET status = '".$conf_nbc_UserAdvManager[7]."'
          WHERE user_id = '".$data['user_id']."'
        ;";
        pwg_query($query);
      }
  
      return true;
    }
  }
  else
    return false;
  
}



function NotSensibleSearchUsername($username)
{
  global $conf;
  
  if ( isset($username) )
  {
    $query = "
      SELECT ".$conf['user_fields']['username']."
      FROM ".USERS_TABLE."
      WHERE LOWER(".$conf['user_fields']['username'].") = '".strtolower($username)."'
    ;";
    list($username) = mysql_fetch_row(pwg_query($query));

    return isset($username) ? $username : '';
  }
}



function SearchMail($email)
{
  global $conf, $lang;
  
  if ( isset($email) )
  {
    $query = "
      SELECT COUNT(*)
      FROM ".USERS_TABLE."
      WHERE ".$conf['user_fields']['email']." = '".$email."'
    ;";
    list($nbr_mail) = mysql_fetch_row(pwg_query($query));
  
    return isset($nbr_mail) ? $nbr_mail : 0;
  }
}



function ValidateUsername($login)
{
  global $conf;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  if ( isset($login) and isset($conf_nbc_UserAdvManager[10]) and $conf_nbc_UserAdvManager[10] <> '' )
  {
    if ( ereg("[".$conf_nbc_UserAdvManager[10]."]", $login) )
      return false;
    else
      return true;
  }
  else
  {
    return true;
  }
}



?>
